SystemOrganization addCategory: #DocumentLogic!

TestCase subclass: #DocTest
	instanceVariableNames: 'doc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

DocTest subclass: #DirtyLoadedDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

!DirtyLoadedDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:09'!
isAbstract 
^false! !

!DirtyLoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:10'!
docShouldBeDirty
^true! !

!DirtyLoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:09'!
docShouldBeNew
^false! !

!DirtyLoadedDocTest methodsFor: 'running' stamp: 'HwaJong 10/3/2012 18:09'!
setUp
super setUp.
doc load.
doc modify.! !

!DirtyLoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:11'!
whatShouldDocDoWhenUserLoads
^#askUserSaveOrSaveAsOrDiscardThenLoad! !

!DirtyLoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:12'!
whatShouldDocDoWhenUserSaves
^#saveToLoadMedium! !

DocTest subclass: #DirtyNewDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

!DirtyNewDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:54'!
isAbstract
^false! !

!DirtyNewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:57'!
docShouldBeDirty
^true! !

!DirtyNewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:55'!
docShouldBeNew
^true! !

!DirtyNewDocTest methodsFor: 'running' stamp: 'HwaJong 10/3/2012 17:53'!
setUp
super setUp.
doc := Doc new.
doc modify.! !

!DirtyNewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:02'!
whatShouldDocDoWhenUserLoads
^#askUserSaveOrSaveAsOrDiscardThenLoad! !

!DirtyNewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:02'!
whatShouldDocDoWhenUserSaves
^#saveAs! !

!DocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:54'!
isAbstract
^true! !

!DocTest methodsFor: 'running' stamp: 'HwaJong 10/3/2012 18:04'!
setUp
super setUp.
doc := Doc new.! !

!DocTest methodsFor: 'tests' stamp: 'HwaJong 10/3/2012 17:57'!
testIsDirty
self assert: doc isDirty equals: self docShouldBeDirty! !

!DocTest methodsFor: 'tests' stamp: 'HwaJong 10/3/2012 17:57'!
testIsNew
self assert: doc isNew equals: self docShouldBeNew! !

!DocTest methodsFor: 'tests' stamp: 'HwaJong 10/3/2012 18:02'!
testdWhatAreYouGoingToDoWhenUserLoads
self assert: doc whatAreYouGoingToDoWhenUserLoads equals: self whatShouldDocDoWhenUserLoads.! !

!DocTest methodsFor: 'tests' stamp: 'HwaJong 10/3/2012 18:02'!
testdWhatAreYouGoingToDoWhenUserSaves
self assert: doc whatAreYouGoingToDoWhenUserSaves equals: self whatShouldDocDoWhenUserSaves.! !

DocTest subclass: #LoadedDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

!LoadedDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:04'!
isAbstract
^false! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:06'!
docShouldBeDirty
^false! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:05'!
docShouldBeNew
^false! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:05'!
setUp
super setUp.
doc load.! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:07'!
whatShouldDocDoWhenUserLoads
^#load! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:07'!
whatShouldDocDoWhenUserSaves
^#saveToLoadMedium! !

DocTest subclass: #NewDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

!NewDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:54'!
isAbstract
^false! !

!NewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:57'!
docShouldBeDirty
^false! !

!NewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:55'!
docShouldBeNew
^true! !

!NewDocTest methodsFor: 'running' stamp: 'HwaJong 10/3/2012 17:52'!
setUp
super setUp.
doc := Doc new.! !

!NewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:02'!
whatShouldDocDoWhenUserLoads
^#load! !

!NewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:02'!
whatShouldDocDoWhenUserSaves
^#saveAs! !

DocTest subclass: #SavedDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

!SavedDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 22:10'!
isAbstract
^false! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 22:11'!
docShouldBeDirty
^false! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 22:11'!
docShouldBeNew
^false! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 22:13'!
setUp
super setUp.
doc saveAs.! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 22:13'!
whatShouldDocDoWhenUserLoads
^#load! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 22:14'!
whatShouldDocDoWhenUserSaves
^#saveToLoadMedium! !

Object subclass: #DocumentLogic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

DocumentLogic subclass: #Doc
	instanceVariableNames: 'isNew isDirty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

!Doc methodsFor: 'initialize-release' stamp: 'HwaJong 10/3/2012 16:40'!
initialize 
super initialize.
isNew := true.
isDirty := false.! !

!Doc methodsFor: 'testing' stamp: 'HwaJong 10/3/2012 16:39'!
isDirty
^isDirty! !

!Doc methodsFor: 'testing' stamp: 'HwaJong 10/3/2012 16:38'!
isNew
^isNew! !

!Doc methodsFor: 'actions' stamp: 'HwaJong 10/3/2012 18:06'!
load
isNew := false.! !

!Doc methodsFor: 'actions' stamp: 'HwaJong 10/3/2012 17:49'!
modify
isDirty := true.! !

!Doc methodsFor: 'actions' stamp: 'HwaJong 10/3/2012 22:13'!
saveAs
isNew := false.
isDirty := false.! !

!DocumentLogic methodsFor: 'query' stamp: 'HwaJong 10/3/2012 22:21'!
whatAreYouGoingToDoWhenUserLoads
^self isDirty
	ifTrue: [#askUserSaveOrSaveAsOrDiscardThenLoad]
	ifFalse: [#load]
! !

!DocumentLogic methodsFor: 'query' stamp: 'HwaJong 10/3/2012 22:21'!
whatAreYouGoingToDoWhenUserSaves
^self isNew
	ifTrue: [#saveAs]
	ifFalse: [#saveToLoadMedium]! !
